const OSS = require('ali-oss')
const router = require('@/router');
const Minio = require('minio')
const stream = require('stream')
import Vue from 'vue'
import { customerHttp, OSSclose } from "@/utils/multipartUpload/oss"
import { exist, AWSclose } from "@/utils/multipartUpload/aws"
const { GetObjectStoreToken } = require('../api/user.js')
const {
  S3Client,
} = require("@aws-sdk/client-s3");

Vue.prototype.OSSclientConfig = {
}


async function ossGenerateSTS() {
  let res = await GetObjectStoreToken()
  Vue.prototype.OSSclientConfig = { ...res.Result[res.Result.ObjectStoreUse] }
  Vue.prototype.OSSclientConfig.ObjectStoreUse = res.Result.ObjectStoreUse;
  Vue.prototype.OSSclientConfig.basePath = Vue.prototype.OSSclientConfig.viewEndpoint
  switch (res.Result.ObjectStoreUse) {
    case 'AliyunOSS':
      Vue.prototype.OSSclientConfig.bucket = Vue.prototype.OSSclientConfig.bucketName
      Vue.prototype.OSSclientConfig.stsToken = Vue.prototype.OSSclientConfig.securityToken
      Vue.prototype.OSSclientConfig.timeout = 10 * 60 * 1000
      let OSSclient = new OSS(Vue.prototype.OSSclientConfig)
      Vue.prototype.OSSclient = {
        put: function (objectName, object) {
          return new Promise(async (resolve, reject) => {
            try {
              let config = await getSTSToken(Vue.prototype.OSSclientConfig.Expiration);
              if (config) {
                Vue.prototype.OSSclientConfig = { ...config.Result[res.Result.ObjectStoreUse] }
                Vue.prototype.OSSclientConfig.ObjectStoreUse = config.Result.ObjectStoreUse;
                Vue.prototype.OSSclientConfig.basePath = Vue.prototype.OSSclientConfig.viewEndpoint;
                Vue.prototype.OSSclientConfig.bucket = Vue.prototype.OSSclientConfig.bucketName
                Vue.prototype.OSSclientConfig.stsToken = Vue.prototype.OSSclientConfig.securityToken
                Vue.prototype.OSSclientConfig.timeout = 10 * 60 * 1000
                OSSclient = new OSS(Vue.prototype.OSSclientConfig);
              }
              let _vm = router.default.app
              if (_vm._route.path !== '/trials/trials-panel/visit/crc-upload') {
                var objectItem = objectName.split('/')
                objectItem[objectItem.length - 1] = new Date().getTime() + '_' + objectItem[objectItem.length - 1]
                objectName = objectItem.join('/')
              }
              let res = await OSSclient.put(objectName, object)
              if (res && res.url) {
                resolve({
                  name: objectName,
                  url: res.url
                })
              } else {
                reject()
              }
            } catch (e) {
              console.log(e)
              reject()
            }
          })
        },
        multipartUpload: (data, progress) => {
          return new Promise(async (resolve, reject) => {
            try {
              const { file, path } = data;
              if (!file || !path) return reject('file and path be required');
              let config = await getSTSToken(Vue.prototype.OSSclientConfig.Expiration);
              if (config) {
                Vue.prototype.OSSclientConfig = { ...config.Result[res.Result.ObjectStoreUse] }
                Vue.prototype.OSSclientConfig.ObjectStoreUse = config.Result.ObjectStoreUse;
                Vue.prototype.OSSclientConfig.basePath = Vue.prototype.OSSclientConfig.viewEndpoint;
                Vue.prototype.OSSclientConfig.bucket = Vue.prototype.OSSclientConfig.bucketName
                Vue.prototype.OSSclientConfig.stsToken = Vue.prototype.OSSclientConfig.securityToken
                Vue.prototype.OSSclientConfig.timeout = 10 * 60 * 1000
                OSSclient = new OSS(Vue.prototype.OSSclientConfig);
              }
              let _vm = router.default.app
              if (_vm._route.path !== '/trials/trials-panel/visit/crc-upload') {
                var objectItem = data.path.split('/')
                objectItem[objectItem.length - 1] = new Date().getTime() + '_' + objectItem[objectItem.length - 1]
                data.path = objectItem.join('/')
              }
              let res = await customerHttp(OSSclient, data, progress);
              if (res) {
                resolve({
                  name: data.path,
                  url: Vue.prototype.OSSclientConfig.viewEndpoint + res.name
                })
              } else {
                reject()
              }
            } catch (err) {
              console.log(err)
              reject(err)
            }
          })
        },
        close: () => {
          OSSclose();
        }
      }
      break
    case 'MinIO':
      let minioClient = new Minio.Client(Vue.prototype.OSSclientConfig);
      Vue.prototype.OSSclient = {
        put: function (objectName, object) {
          return new Promise(async (resolve, reject) => {
            try {
              var name = objectName.split('/')[objectName.split('/').length - 1]
              let _vm = router.default.app
              if (_vm._route.path !== '/trials/trials-panel/visit/crc-upload') {
                var objectItem = objectName.split('/')
                objectItem[objectItem.length - 1] = new Date().getTime() + '_' + objectItem[objectItem.length - 1]
                objectName = objectItem.join('/')
              }
              const reader = new FileReader();
              reader.onload = (ex) => {
                const bufferStream = new stream.PassThrough()
                bufferStream.end(Buffer.from(ex.target.result))
                minioClient.putObject(Vue.prototype.OSSclientConfig.bucketName, objectName, bufferStream, function (err, etag) {
                  if (err) {
                    console.log(err)
                    reject()
                  } else {
                    resolve({
                      name: objectName,
                      url: Vue.prototype.OSSclientConfig.viewEndpoint + decodeUtf8(objectName)
                    })
                  }
                })
              };
              reader.readAsArrayBuffer(object);
            } catch (e) {
              console.log(e)
            }
          })
        },
        close: () => {
          return false
        }
      }
      break
    case 'AWS':
      let aws = new Minio.Client(Vue.prototype.OSSclientConfig);
      Vue.prototype.OSSclient = {
        put: function (objectName, object) {
          return new Promise(async (resolve, reject) => {
            try {
              var name = objectName.split('/')[objectName.split('/').length - 1]
              let _vm = router.default.app
              if (_vm._route.path !== '/trials/trials-panel/visit/crc-upload') {
                var objectItem = objectName.split('/')
                objectItem[objectItem.length - 1] = new Date().getTime() + '_' + objectItem[objectItem.length - 1]
                objectName = objectItem.join('/')
              }
              const reader = new FileReader();
              reader.onload = (ex) => {
                const bufferStream = new stream.PassThrough()
                bufferStream.end(Buffer.from(ex.target.result))
                aws.putObject(Vue.prototype.OSSclientConfig.bucketName, objectName, bufferStream, function (err, etag) {
                  if (err) {
                    console.log(err)
                    reject()
                  } else {
                    console.log(objectName);
                    resolve({
                      name: objectName,
                      url: Vue.prototype.OSSclientConfig.viewEndpoint + decodeUtf8(objectName)
                    })
                  }
                })
              };
              reader.readAsArrayBuffer(object);
            } catch (e) {
              console.log(e)
            }
          })
        },
        multipartUpload: (data, progress) => {
          return new Promise(async (resolve, reject) => {
            try {
              const { file, path } = data;
              if (!file || !path) return reject('file and path be required');
              let config = await getSTSToken(Vue.prototype.OSSclientConfig.Expiration);
              if (config) {
                Vue.prototype.OSSclientConfig = { ...config.Result[res.Result.ObjectStoreUse] }
                Vue.prototype.OSSclientConfig.ObjectStoreUse = config.Result.ObjectStoreUse;
                Vue.prototype.OSSclientConfig.basePath = Vue.prototype.OSSclientConfig.viewEndpoint;
                Vue.prototype.OSSclientConfig.bucket = Vue.prototype.OSSclientConfig.bucketName
                Vue.prototype.OSSclientConfig.stsToken = Vue.prototype.OSSclientConfig.securityToken
                Vue.prototype.OSSclientConfig.timeout = 10 * 60 * 1000
                OSSclient = new S3Client(Vue.prototype.OSSclientConfig);
              }
              let _vm = router.default.app
              if (_vm._route.path !== '/trials/trials-panel/visit/crc-upload') {
                var objectItem = data.path.split('/')
                objectItem[objectItem.length - 1] = new Date().getTime() + '_' + objectItem[objectItem.length - 1]
                data.path = objectItem.join('/')
              }
              await exist(OSSclient, Vue.prototype.OSSclientConfig.bucket, data, progress, (res) => {
                if (res) {
                  resolve({
                    name: data.path,
                    url: Vue.prototype.OSSclientConfig.viewEndpoint + res.name
                  })
                } else {
                  reject()
                }
              });

            } catch (err) {
              console.log(err)
              reject(err)
            }
          })
        },
        close: () => {
          AWSclose();
        }
      }
  }
  return
}
function decodeUtf8(bytes) {
  let str = bytes.split('?');
  let str2 = str[0].split('/');
  let name = str2[str2.length - 1];
  name = encodeURIComponent(name);
  str.shift();
  str2.pop();
  return str2.join("/") + '/' + name;
}
const queue = []
let loading = false;
// 获取凭证
function getSTSToken(credentials) {
  return new Promise(async (resolve, reject) => {
    let isExpired = isCredentialsExpired(credentials);
    if (!isExpired) {
      if (loading) {
        queue.push({ resolve, reject })
      }
      if (!loading) {
        loading = true;
        let res = await GetObjectStoreToken();
        loading = false;
        resolve(res)
        let p = queue.shift();
        while (p) {
          p.resolve(res)
          p = queue.shift();
        }
      }

    } else {
      console.log("凭证未过期");
      resolve(false)
    }

  })
}
/**
* oss判断临时凭证是否到期。
**/
function isCredentialsExpired(credentials) {
  if (!credentials) {
    return true;
  }
  const expireDate = new Date(credentials.Expiration);
  const now = new Date();
  // 如果有效期不足五分钟，视为过期。
  return expireDate.getTime() - now.getTime() <= 300000;

}

export const OSSclient = ossGenerateSTS
